#include "helpers.h"

/* TODO: cmdline */
static enum log_level global_loglevel = DEBUGLEVEL;

/* Note: This routine allocates memory for output. Remember to free it */
/* This routine also does no locking. Please remember this */
void
compressBlock(mpbz2_queue_item *item) {
  /* Until we understand libbzip2, just do nothing, output the same thing 
   * that is input */
  bz_stream strm;
  
  if(item == NULL) {
    return;
  }

  strm.opaque=NULL;
  strm.bzalloc=NULL;
  strm.bzfree=NULL;
 
  BZ2_bzCompressInit(&strm,BZ2_BLOCKFACTOR,BZ2_VERBOSITY,BZ2_WORKFACTOR);
  strm.next_in=(char *)item->input->data;
  strm.avail_in=item->input->len;
  
  /* Is this a bad assumption? */
  item->output = mpbz2_create_buffer(item->input->len + BLOCK_SIZE, true);
  strm.next_out=(char *)item->output->data;
  strm.avail_out=item->output->size;
  
  /* FIXME need proper error handling */
  BZ2_bzCompress(&strm,BZ_RUN);
  BZ2_bzCompress(&strm,BZ_FINISH);
  //in->outlen=(strm.total_out_hi32 << 32) + strm.total_out_lo32;
  item->output->len=strm.total_out_lo32;
  BZ2_bzCompressEnd(&strm);
}

/* taken from fileutils... yay GPL (and thanks GNU for the code) */
/* modded to use fwrite */
size_t
fullWrite (FILE* dest, const void *ptr, size_t len) {
  size_t total_written = 0;

  while (len > 0) {
    size_t written = fwrite (ptr, 1, len, dest);
    if (written <= 0) {
      /* Some buggy drivers return 0 when you fall off a device's end.  */
      if (written == 0)
	errno = ENOSPC;
#ifdef EINTR
      if (errno == EINTR)
	continue;
#endif
      break;
    }
    total_written += written;
    ptr += written;
    len -= written;
  }
  return total_written;
}

void
logMsg(int level,const char *msg,...) {
  va_list ap;
  va_start(ap,msg);
  if (level <= global_loglevel) {
    vfprintf(stderr,msg,ap);
  }
}
